//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void TfrmMain::Test()
{
    sqlite3* 		pSQLite3 	= NULL;
    sqlite3_stmt* 	pStmt 		= NULL;
    char*			szErrMsg 	= NULL;
    const char* 	szErr;

    String strMsg;

    // Open Database
    int rst = sqlite3_open( "test.db", &pSQLite3 );

    memProc->Lines->Clear();
    memProc->Lines->Append( L"Test Start...\n" );

    if ( rst )
    {
        strMsg.sprintf( L"\t Can't open database: %s\n", sqlite3_errmsg( pSQLite3 ) );
        memProc->Lines->Append( strMsg );
    }
    else
    {
    	memProc->Lines->Append( L"\t Database (test.db) Opened...\n" );

        AnsiString strQuery;

        // ̺ 
        strQuery = "CREATE TABLE IF NOT EXISTS TestTable ("
        	"	 name 		VARCHAR(20)"
            "	,age	    int"
            "	,country	VARCHAR(20)"
            ")";
        rst = sqlite3_exec(pSQLite3, strQuery.c_str(), NULL, 0, &szErrMsg);

        if ( rst == SQLITE_OK )
        {
        	memProc->Lines->Append( L"\t Test Table Created... OK\n" );
        }
        else
        {
        	memProc->Lines->Append( L"\t Test Table Created... FAILE\n" );

            strMsg.sprintf( L"\t\t Error %d : %s", sqlite3_errcode( pSQLite3 ), sqlite3_errmsg16( pSQLite3 ) );
            memProc->Lines->Append( strMsg );
        }

        // Inserting...
        memProc->Lines->Append( L"\t Inserting... \n" );
        strQuery = "INSERT INTO TestTable ( name, age, country) VALUES ( ?, ?, ? );";
        if ( sqlite3_prepare_v2( pSQLite3, strQuery.c_str(), strQuery.Length(), &pStmt, &szErr ) == SQLITE_OK )
        {
        	for ( int i = 0; i < 10; ++i )
            {
                AnsiString strName;
                strName.sprintf( "name%d", i );

                sqlite3_bind_text( pStmt, 1, strName.c_str(), strName.Length(), NULL );
                sqlite3_bind_int(  pStmt, 2, i );

                AnsiString strCountry;
                sqlite3_bind_text( pStmt, 3, strCountry.c_str(), strCountry.Length(), NULL );

                sqlite3_step( pStmt );

                int nLast = sqlite3_last_insert_rowid( pSQLite3 );

                strMsg.sprintf( L"\t\t Inserted... OK (%d)\n", nLast );
                memProc->Lines->Append( strMsg );

                sqlite3_reset( pStmt );
            }

            sqlite3_finalize( pStmt );
        }
        else
        {
        	memProc->Lines->Append( L"\t Inserting... FAILE\n" );

            strMsg.sprintf( L"\t\t Error %d : %s", sqlite3_errcode( pSQLite3 ), sqlite3_errmsg16( pSQLite3 ) );
            memProc->Lines->Append( strMsg );
        }

        memProc->Lines->Append( L"\t Selecting... \n" );
        strQuery = "SELECT COUNT(*) FROM TestTable;";
        if ( sqlite3_prepare_v2( pSQLite3, strQuery.c_str(), strQuery.Length(), &pStmt, &szErr ) == SQLITE_OK )
        {
			int nRow = sqlite3_data_count( pStmt );
            int nCol = sqlite3_column_count( pStmt );

			const char* col1name = sqlite3_column_name( pStmt, 0 );

            int nRowCnt = 0;
            while ( sqlite3_step( pStmt ) == SQLITE_ROW )
            {
                ++nRowCnt;

                int Count = sqlite3_column_int( pStmt, 0 );

                strMsg.sprintf( L"\t\t Row Count ... %d\n", Count );
                memProc->Lines->Append( strMsg );
            }
        }
        else
        {
        	memProc->Lines->Append( L"\t Selecting... FAILE\n" );

            strMsg.sprintf( L"\t\t Error %d : %s", sqlite3_errcode( pSQLite3 ), sqlite3_errmsg16( pSQLite3 ) );
            memProc->Lines->Append( strMsg );
        }

        // Updating...
        memProc->Lines->Append( L"\t Updating... \n" );
        strQuery = "UPDATE TestTable SET country = :country WHERE age < :age;";
        if ( sqlite3_prepare_v2( pSQLite3, strQuery.c_str(), strQuery.Length(), &pStmt, &szErr ) == SQLITE_OK )
        {
			sqlite3_bind_text( pStmt, 1, "KOREA", 5, NULL );
            sqlite3_bind_int( pStmt, 2, 5 );

            sqlite3_step( pStmt );
            int nUpdated = sqlite3_changes( pSQLite3 );

            strMsg.sprintf( L"\t\t Updated... %d Rows", nUpdated );
            memProc->Lines->Append( strMsg );
        }
        else
        {
        	memProc->Lines->Append( L"\t Updating... FAILE\n" );

            strMsg.sprintf( L"\t\t Error %d : %s", sqlite3_errcode( pSQLite3 ), sqlite3_errmsg16( pSQLite3 ) );
            memProc->Lines->Append( strMsg );
        }

        // Deleting...
        memProc->Lines->Append( L"\t Deleting... \n" );
        strQuery = "DELETE FROM TestTable WHERE age < :age;";
        if ( sqlite3_prepare_v2( pSQLite3, strQuery.c_str(), strQuery.Length(), &pStmt, &szErr ) == SQLITE_OK )
        {
            sqlite3_bind_int( pStmt, 1, 2 );

            sqlite3_step( pStmt );
            int nUpdated = sqlite3_changes( pSQLite3 );

            strMsg.sprintf( L"\t\t Deleted... %d Rows", nUpdated );
            memProc->Lines->Append( strMsg );
        }
        else
        {
        	memProc->Lines->Append( L"\t Updating... FAILE\n" );

            strMsg.sprintf( L"\t\t Error %d : %s", sqlite3_errcode( pSQLite3 ), sqlite3_errmsg16( pSQLite3 ) );
            memProc->Lines->Append( strMsg );
        }

        // ̺ 
        strQuery = "DROP TABLE IF EXISTS TestTable;";
        rst = sqlite3_exec(pSQLite3, strQuery.c_str(), NULL, 0, &szErrMsg);

        if ( rst == SQLITE_OK )
        {
        	memProc->Lines->Append( L"\t Test Table Deleted... OK\n" );
        }
        else
        {
        	memProc->Lines->Append( L"\t Test Table Deleted... FAILE\n" );

            strMsg.sprintf( L"\t\t Error %d : %s", sqlite3_errcode( pSQLite3 ), sqlite3_errmsg16( pSQLite3 ) );
            memProc->Lines->Append( strMsg );
        }

        sqlite3_close( pSQLite3 );
        memProc->Lines->Append( L"\t Database (test.db) Closed...\n" );

        pSQLite3 = NULL;
    }

    memProc->Lines->Append( L"Test End...\n" );
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnTestClick(TObject *Sender)
{
	Test();
}
//---------------------------------------------------------------------------

